package com.example.nekontakte.subscribes.model;

import java.util.Objects;

import com.example.nekontakte.core.model.BaseEntity;
import com.example.nekontakte.users.model.UserEntity;

import jakarta.persistence.Entity;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.ManyToOne;
import jakarta.persistence.Table;

@Entity
@Table(name = "subscribes")
public class SubscribeEntity extends BaseEntity {
    @ManyToOne
    @JoinColumn(name = "userId", nullable = false)
    private UserEntity user;
    @ManyToOne
    @JoinColumn(name = "subscriberId", nullable = false)
    private UserEntity subscriber;

    public SubscribeEntity() {
    }

    public UserEntity getUser() {
        return user;
    }

    public void setUser(UserEntity user) {
        this.user = user;
    }

    public UserEntity getSubscriber() {
        return subscriber;
    }

    public void setSubscriber(UserEntity subscriber) {
        this.subscriber = subscriber;
    }

    @Override
    public int hashCode() {
        return Objects.hash(
                id,
                user,
                subscriber);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj)
            return true;
        if (obj == null || getClass() != obj.getClass())
            return false;
        final SubscribeEntity other = (SubscribeEntity) obj;
        return Objects.equals(other.getId(), id) &&
                Objects.equals(other.getUser(), user) &&
                Objects.equals(other.getSubscriber(), subscriber);
    }

}
